require 'sketchup.rb'
require 'extensions.rb'
module CURIC
  module FaceArray
    PLUGIN            = self
    PLUGIN_NAMESPACE  = 'Curic'.freeze
    PLUGIN_ID         = 'Face Array'.freeze
    PLUGIN_NAME       = "#{PLUGIN_NAMESPACE} #{PLUGIN_ID}".freeze
    PLUGIN_VERSION    = '0.7.1-yagi'.freeze

    FILENAMESPACE = File.basename(__FILE__, '.*')
    PATH_ROOT     = File.dirname(__FILE__).freeze
    PATH          = File.join(PATH_ROOT, FILENAMESPACE).freeze

    # Sketchup.require "#{PATH}/load_rubyencoder_helper"

    unless file_loaded?(__FILE__)
      ex = SketchupExtension.new(PLUGIN_NAME, "#{PATH}/loader")
      ex.version     = PLUGIN_VERSION
      ex.copyright   = 'Curic © 2024-2027'
      ex.creator     = 'Vo Quoc Hai (curic4su@gmail.com)'
      ex.description = 'Array objects along a face.'
      Sketchup.register_extension(ex, true)
      PLUGIN_EX = ex
    end
  end
end

file_loaded(__FILE__)
