// ELEMENT.locale(ELEMENT.lang.en)

var app = new Vue({
  el: '#app',
  data: function() {
    return {
      patterns: [
        {
          label: 'Standard',
          value: 'Standard',
        },
        {
          label: 'Herringbone',
          value: 'Herringbone',
        },
        {
          label: 'Chevron',
          value: 'Chevron',
        },
        {
          label: 'Basket Weave',
          value: 'Basket Weave',
        },
        {
          label: 'Cubic',
          value: 'Cubic',
        },
        {
          label: 'Hexagon',
          value: 'Hexagon',
        }
      ],
      libs: [
        {
          name: 'Standard',
          file: 'standard.json',
          thumbnail: 'standard.jpg'
        },
        {
          name: 'Herringbone',
          file: 'herringbone.json',
          thumbnail: 'herringbone.jpg'
        },
        {
          name: 'Chevron',
          file: 'chevron.json',
          thumbnail: 'chevron.jpg'
        },
        {
          name: 'Basket Weave',
          file: 'basket_weave.json',
          thumbnail: 'basket_weave.jpg'
        },
        {
          name: 'Cubic',
          file: 'cubic.json',
          thumbnail: 'cubic.jpg'
        },
        {
          name: 'Hexagon',
          file: 'hexagon.json',
          thumbnail: 'hexagon.jpg'
        }
      ],
      activePattern: 'Standard',
      dialogLib: false,
      layout: {
        repeat_x: {
          x: null,
          y: null,
        },
        // repeat_x : null,
        repeat_y: {
          x: null,
          y: null,
        },
      },
      pattern: {
        name: '',
        definition: '',
        lenx: null,
        leny: null,
      },
      surface: {
        area: null,
        material: null
      },
      selected_array_object: false,
      material: {},
      on_layout: true,
      windowWidth: window.outerWidth,
      windowHeight: window.outerHeight
    }
  },
  methods: {
    controlChangeValue: function (c) {
      sketchup.controlChangeValue(c)
    },
    redraw: function (c) {
      sketchup.redraw(this.material)
    },
    changeLayout(){
      sketchup.changeLayout(this.layout);
    }, 
    changeLayoutAngle(){
      sketchup.changeLayoutAngle(this.layout.angle);
    },    
    resetLayout(){
      sketchup.resetLayout();
    },
    changePatternBorderOption(){
      sketchup.changePatternBorderOption(this.layout);
    },    
    refreshPatternThumbnail(){
      sketchup.refreshPatternThumbnail();
    },
    arrayPattern(){
      sketchup.arrayPattern(this.layout, this.pattern);
    }, 
    editArrayObject(){
      sketchup.editArrayObject();
    },  
    editInPlace(){
      sketchup.editInPlace();
    },
    savePattern(){
      sketchup.savePattern();
    },
    openLibrary(){
      this.dialogLib = true;
    },
    handleCloseLib(){
      this.dialogLib = false;
    },
    selectPattern(lib){
      sketchup.selectPattern(lib);
      this.dialogLib = false;
    },
  },
  computed:{
  },
  mounted: function() {
    sketchup.ready(window.outerWidth, window.outerHeight);

    // event resize
    window.addEventListener('resize', function() {
      app.windowWidth = window.outerWidth;
      app.windowHeight = window.outerHeight;
    });
  },
})

function updateLayout(layout) {
  // console.log(layout)
  app.layout = layout;
}

function updatePattern(pattern) {
  // console.log(pattern)
  app.pattern = pattern;
}

function updateData(material) {
  app.material = material;
}

function updateSurface(surface) {
  app.surface = surface;
}
function updateLibrary(libs){
  app.libs = libs;
}